<?php

/**
 * co_cdps_ep actions.
 *
 * @package    contratacion
 * @subpackage co_cdps_ep
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_cdps_epActions extends sfQuery {

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    //Cambio tabla CO_CDPS_V por CO_CDPS_ALL_V que tiene todos los CDP, se buscan por numero y si es del SG - 20160107
    //Se verifica cambios de relacion para SGR - 20200518::LAVILA
    protected $table_names = array(
        'CO_CDPS_EP',
        'CO_ESTUDIOS_PREVIOS_V',
        'CO_CDPS_ALL_V',
        'CO_PROYECTO_EP',
        'CO_PROYECTOS_ALL_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_ESTUDIOS_PREVIOS_V' =>
        array(
            'id_estudios_previos' => 'CO_CDPS_EP'
        ),
        'CO_PROYECTO_EP' =>
        array(
            'id_cpo_ep-id_proyecto_ep' => 'CO_CDPS_EP',
            'id_estudios_previos' => 'CO_CDPS_EP',
            'sgr' => 'CO_CDPS_EP'
        ),
        'CO_PROYECTOS_ALL_V' =>
        array(
            'id_cpo-id' => 'CO_PROYECTO_EP',
            'sgr' => 'CO_PROYECTO_EP'
        ),
        'CO_CDPS_ALL_V, LEFT' =>
        array(
            'id_cdp-cdp' => 'CO_CDPS_EP',
            'sgr' => 'CO_CDPS_EP',
            'id_cpo-id_cpo' => 'CO_PROYECTO_EP'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CDPS_EP' =>
        array(
            'id_cdps_ep' => 'id_cdps_ep',
            'id_estudios_previos' => 'id_estudios_previos',
            'id_cdp' => 'id_cdp',
            'id_cpo_ep' => 'id_cpo_ep',
            'valor' => 'valor',
            'sgr' => 'sgr'
        ),
        'CO_ESTUDIOS_PREVIOS_V' =>
        array(
            'proceso' => 'proceso',
            'modalidad' => 'modalidad'
        ),
        'CO_PROYECTOS_ALL_V' =>
        array(
            'codigo' => 'codigo_proyecto',
            'descripcion' => 'descripcion_proyecto',
            'ano_fiscal' => 'ano_fiscal'
        ),
        'CO_CDPS_ALL_V' =>
        array(
            'cdp' => 'cdp',
            'fecha' => 'fecha_cdp',
            'saldo' => 'saldo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CDPS_EP' => array(
            'id_cdps_ep,a' => array('!=' => array(-1)),
            'id_cdps_ep,b' => array('=' => array('id_cdps_ep')),
            'id_estudios_previos' => array('=' => array('id_estudios_previos')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_cdp'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_cdps_ep'; //identificador de la tabla
    protected $id_names = array('id_cdps_ep'); //llave primaria
    protected $field_names = array('id_estudios_previos', 'id_cdp', 'id_cpo_ep', 'valor', 'sgr'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CDPS_EP'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    protected $campo_fecha_sistema = array();


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_cdps_ep'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {


        //Obtenemos la entidad
        $array = sfYaml::load(dirname(__FILE__) . '/../../../../api/config/app-gwt.yml');
        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_cdp = $request['id_cdp'];
        $id_estudios_previos = $request['id_estudios_previos'];
        $valor_a_reservar = $request['valor'];
        $id_cpo_ep = $request['id_cpo_ep'];


        $sql = <<<EOD
select valor from co_estudios_previos where id_estudios_previos = $id_estudios_previos
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $valor_ep = $records[0]['valor'];

        //Se cambia campo de sgr por campo_sgr, ya que este se cambia a true y false - 20170315
        $sql = <<<EOD
select cdp.*, cdp.sgr as campo_sgr  from co_cdps_v cdp where cdp.id = $id_cdp
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $valor_cdp = $records[0]['saldo'];
        $campo_cdp = $records[0]['cdp'];
        $campo_sgr = $records[0]['campo_sgr'];

        $sql = <<<EOD
select id_cpo from co_proyecto_ep where id_proyecto_ep = $id_cpo_ep
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $id_cpo = $records[0]['id_cpo'];

        
        //SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7, CEV-8, CEV PUB-9
        if ($entidadCliente == 2) {
            /**
             * Se valida para ANM que no aplique para otro EP - 20210303::LAVILA
             */
            $sql = <<<EOD
select count(*) as cantidad, to_char( wm_concat(distinct id_estudios_previos) ) as ids_ep 
    from co_cdps_ep 
    where id_cdp = $campo_cdp 
        and id_cpo_ep = $id_cpo_ep
EOD;

            $records = CN_TABLE::executeSQL($sql);
            $cantidad = $records[0]['cantidad'];
            $ids_ep = $records[0]['ids_ep'];
            if ($cantidad > 0) {
                $errors['mensaje'] = "Este CDP ya se esta usando en otro Proceso(" . $ids_ep . ")";
                $errors['servicio'] = "co_cdps_ep";
            }
        }


        $sql = <<<EOD
select nvl(valor,0) valor from co_cdps_ep where id_estudios_previos = $id_estudios_previos
EOD;

        $records = CN_TABLE::executeSQL($sql);


        $valor_reservado = 0;
        foreach ($records as $cdps) {
            $valor_reservado += $cdps['valor'];
        }

        $sql = <<<EOD
select nvl(valor,0) valor from co_aporte_externo where id_estudios_previos = $id_estudios_previos
EOD;

        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $aportes) {
            $valor_reservado += $aportes['valor'];
        }

        $sql = <<<EOD
select count(*) cantidad 
    from co_cdps_ep 
    where id_estudios_previos = $id_estudios_previos 
        and id_cdp = $campo_cdp 
            and id_cpo_ep = $id_cpo_ep
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $cantidad = $records[0]['cantidad'];

        $saldo_ep = $valor_ep - $valor_reservado;

        //SI EL VALOR QUE SE ESTA ASIGNANDO ES MAYOR AL SALDO DEL ESTUDIO PREVIO
        if ($valor_a_reservar > $saldo_ep) {

            $errors['mensaje'] = "El valor registrado es mayor al saldo del Proceso de Estudios Previos";
            $errors['servicio'] = "co_cdps_ep";

            //SI EL VALOR QUE SE ESTA ASIGNANDO ES MAYOR AL SALDO DEL CDP
        }
        /*
         * Actualizacion: 16 de Abril 2015
         * Por Solicitud de Nidya se inactiva temporalmente la validación.
         * Actualizacion: 23 de Abril 2015
         * Por solicitud de Nydia se activa nuevamente la validación.
         * */
        if ($valor_a_reservar > $valor_cdp) {
            $errors['mensaje'] = "El valor registrado es mayor al saldo del CDP";
            $errors['servicio'] = "co_cdps_ep";
        }

        //SI EL CDP YA SE ENCUENTRA ASIGNADO A UN PROCESO
        if ($cantidad > 0) {
            $errors['mensaje'] = "Este CDP ya se esta usando para el Proceso";
            $errors['servicio'] = "co_cdps_ep";
        }

        //SI EL VALOR A RESERVAR ES MAYOR AL VALOR ASIGNADO POR PROYECTO
        $sql = <<<EOD
select nvl(valor,0) valor from co_proyecto_ep where id_estudios_previos = $id_estudios_previos and id_cpo = $id_cpo
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $valor_proyecto = $records[0]['valor'];

        if ($valor_a_reservar > $valor_proyecto) {

            $errors['mensaje'] = "El valor registrado es mayor al valor asignado al proyecto. Favor verificar";
            $errors['servicio'] = "co_cdps_ep";
        }

        /**
         * Se cambia el id del cdp de la vista por el numero del CDP, y se guarda si es SGR o no - 20160107
         */
        $request['id_cdp'] = $campo_cdp;
        $request['sgr'] = $campo_sgr;
        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $id_cdps_ep = $request['id_cdps_ep'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        /**
         * Verificar si fue registrado por linea PAA - 20200416::LAVILA
         */
        $sql = <<<EOD
SELECT
*
FROM co_estudios_previos_v
where
id_estudios_previos in (SELECT id_estudios_previos FROM co_proyecto_ep 
    where id_proyecto_ep in (select id_cpo_ep from co_cdps_ep where id_cdps_ep = $id_cdps_ep))
and codigopaa is not null                 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */

        if (count($records) > 0) {
            $errors['mensaje'] = "El CDP del EP fue registrado por lineaPAA no se peude eliminar registro, favor verificar.";
            $errors['servicio'] = "co_proyecto_ep";
        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {





                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
